SystemOrganization addCategory: #STTutTodoApp!
SystemOrganization addCategory: #'STTutTodoApp-UserStories'!
SystemOrganization addCategory: #'STTutTodoApp-Tests'!

WASession subclass: #StSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
database

	^ database! !

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
database: anObject

	database := anObject.! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 14:28'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!StSession methodsFor: 'initializing' stamp: 'micper 4/9/2008 14:20'!
initialize
	
	super initialize.
	self database: StImageDatabase new.! !

!StSession methodsFor: 'comparing' stamp: 'micper 4/9/2008 11:22'!
isLoggedIn

	^ self user isNil not! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
login: aUser
	
	self user: aUser.! !

!StSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
logout

	self user: nil.! !

!StSession methodsFor: 'request handling' stamp: 'micper 4/9/2008 14:29'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!StSession methodsFor: 'private' stamp: 'micper 4/9/2008 14:21'!
unregistered

	self database disconnect.
	super unregistered.! !

!StSession methodsFor: 'updating' stamp: 'micper 4/9/2008 13:54'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: StToDoLibrary applicationName.! !

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user

	^ user! !

!StSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user: anObject

	user := anObject.! !

ACUserStory subclass: #CreateNewTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!CreateNewTask class methodsFor: 'initialize-release' stamp: 'mp 3/31/2011 10:12:40.877'!
initialize
	
	super initialize.
	self userStoryString: 'Create New Task
In order to add a new todo entry
As a user
I want to create a new task with a reminder'. ! !

!CreateNewTask class methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 13:02:02.874'!
libraries

	^ {StWebAppLibrary. StSeleniumLibrary}! !

!CreateNewTask methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 15:07:52.779'!
cancel task creation

	Given I am logged in
	When I click New Task
	And I insert my task as name
	And I insert my notes as description
	And I push the Cancel button
	Then I dont find a todo entry with my task and my notes! !

!CreateNewTask methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 14:56:22.613'!
create a completed task

	Given I am logged in
	When I click New Task
	And I insert my task as name
	And I insert my notes as description
	And I change the task to complete
	And I push the Save button
	Then I find a completed todo entry for tomorrow with my task and my notes! !

!CreateNewTask methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 14:31:23.163'!
create a missed task

	Given I am logged in
	When I click New Task
	And I insert my task as name
	And I insert my notes as description
	And I change the deadline to yesterday
	And I push the Save button
	Then I find a not completed todo entry for yesterday with my task and my notes! !

!CreateNewTask methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 14:27:44.395'!
create a task with an upcoming deadline

	Given I am logged in
	When I click New Task
	And I insert my task as name
	And I insert my notes as description
	And I push the Save button
	Then I find a not completed todo entry for tomorrow with my task and my notes! !

!CreateNewTask methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 13:33:37.634'!
create an empty task

	Given I am logged in
	When I click New Task
	And I push the Save button
	Then I find a not completed todo entry for tomorrow with no title and no description! !

ACUserStory subclass: #EditTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!EditTask class methodsFor: 'initialize-release' stamp: 'mp 3/31/2011 10:17:33.051'!
initialize
	
	super initialize.
	self userStoryString: 'Edit Task
In order to change a task
As a user
I want to edit task details'. ! !

!EditTask class methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 15:24:03.7'!
libraries

	^ {StWebAppLibrary. StSeleniumLibrary}! !

!EditTask methodsFor: 'as yet unclassified' stamp: 'mp 4/1/2011 11:02:16.11'!
cancel editing

Given I have a not completed task with old title and old description for tomorrow
And I am logged in
When I click edit
And I insert new title as name
And I insert new description as description
And I change the deadline to yesterday
And I change the task to complete
And I push the Cancel button
Then I find a not completed todo entry for tomorrow with old title and old description! !

!EditTask methodsFor: 'as yet unclassified' stamp: 'mp 4/1/2011 11:01:44.175'!
change task's complete status

Given I have a not completed task with old title and old description for tomorrow
And I am logged in
When I click edit
And I change the task to complete
And I push the Save button
Then I find a completed todo entry for tomorrow with old title and old description! !

!EditTask methodsFor: 'as yet unclassified' stamp: 'mp 4/1/2011 11:02:12.079'!
change task's deadline

Given I have a not completed task with old title and old description for tomorrow
And I am logged in
When I click edit
And I change the deadline to yesterday
And I push the Save button
Then I find a not completed todo entry for yesterday with old title and old description! !

!EditTask methodsFor: 'as yet unclassified' stamp: 'mp 4/1/2011 11:02:20.554'!
change task's description

Given I have a not completed task with old title and old description for tomorrow
And I am logged in
When I click edit
And I insert new description as description
And I push the Save button
Then I find a not completed todo entry for tomorrow with old title and new description! !

!EditTask methodsFor: 'as yet unclassified' stamp: 'mp 4/1/2011 11:02:23.463'!
change task's name

Given I have a not completed task with old title and old description for tomorrow
And I am logged in
When I click edit
And I insert new title as name
And I push the Save button
Then I find a not completed todo entry for tomorrow with new title and old description! !

ACUserStory subclass: #RegisteraNewUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!RegisteraNewUser class methodsFor: 'initialize-release' stamp: 'mp 3/31/2011 10:07:58.717'!
initialize
	
	super initialize.
	self userStoryString: 'Register a New User
In order to use the ToDo application
As a user
I want to create a personal account'. ! !

!RegisteraNewUser class methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:08:09.857'!
libraries

	^ {StWebAppLibrary. StSeleniumLibrary}! !

!RegisteraNewUser methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:46:19.762'!
register a new user

Given I am on the registration form
When I insert Michael as username
And I insert michael.perscheid@hpi.uni-potsdam.de as email
And I insert secret as password
And I insert secret as repeated password
And I push the Register button
Then I am logged in! !

!RegisteraNewUser methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:21:56.39'!
start registration form

Given the ToDo Application is started
When I click Sign up for the ToDo Application
Then I see Register! !

!RegisteraNewUser methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:53:05.229'!
try to register with already used email

Given I am on the registration form
When I insert Michael as username
And I insert tester@example.org as email
And I insert secret as password
And I insert secret as repeated password
And I push the Register button
Then I notice the error message The e-mail address is already registered!!! !

!RegisteraNewUser methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:54:32.33'!
try to register with different passwords

Given I am on the registration form
When I insert Michael as username
And I insert michael.perscheid@hpi.uni-potsdam.de as email
And I insert secret as password
And I insert notsecret as repeated password
And I push the Register button
Then I notice the error message Your repeated password does not match!!! !

!RegisteraNewUser methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:50:35.909'!
try to register with empty form

Given I am on the registration form
When I push the Register button
Then I notice the error message Please choose a username!!! !

ACUserStory subclass: #ShowTasks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!ShowTasks class methodsFor: 'initialize-release' stamp: 'mp 3/31/2011 10:45:48.392'!
initialize
	
	super initialize.
	self userStoryString: 'Show Tasks
In order to see my todo entries
As a user
I want to recognize tasks filtered by their status'. ! !

!ShowTasks class methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 15:24:18.447'!
libraries

	^ {StWebAppLibrary. StSeleniumLibrary}! !

!ShowTasks methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 15:58:14.796'!
show all tasks

Given I have three different kinds of tasks
And I am logged in
When I click All
Then I find a completed todo entry for yesterday with task1 and completed task
And I find a not completed todo entry for yesterday with task2 and missed task
And I find a not completed todo entry for tomorrow with task3 and still pending task! !

!ShowTasks methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 16:05:21.641'!
show completed tasks

Given I have three different kinds of tasks
And I am logged in 
When I click Completed
Then I find a completed todo entry for yesterday with task1 and completed task
And I dont see a todo entry with task2 and missed task
And I dont see a todo entry with task3 and still pending task! !

!ShowTasks methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 16:05:17.036'!
show missed tasks

Given I have three different kinds of tasks
And I am logged in
When I click Missed
Then I find a not completed todo entry for yesterday with task2 and missed task
And I dont see a todo entry with task1 and completed task
And I dont see a todo entry with task3 and still pending task! !

!ShowTasks methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 16:04:57.033'!
show pending tasks

Given I have three different kinds of tasks
And I am logged in
When I click Pending
Then I find a not completed todo entry for tomorrow with task3 and pending task
And I dont see a todo entry with task1 and completed task
And I dont see a todo entry with task2 and still missed task! !

ACUserStory subclass: #StartToDoApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!StartToDoApplication class methodsFor: 'initialize-release' stamp: 'mp 3/30/2011 16:21:25.674'!
initialize
	
	super initialize.
	self userStoryString: 'Start ToDo Application
In order to manage todos
As a user
I want to start the ToDo Web application'. ! !

!StartToDoApplication class methodsFor: 'as yet unclassified' stamp: 'mp 3/30/2011 16:43:04.097'!
libraries

	^ {StSeleniumLibrary}! !

!StartToDoApplication methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:20:48.397'!
start ToDo Application

Given the web server is up
When I request the url http://localhost:8080/todo
Then I am on the start page
! !

ACUserStory subclass: #UserLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!UserLogin class methodsFor: 'initialize-release' stamp: 'mp 3/31/2011 10:11:19.923'!
initialize
	
	super initialize.
	self userStoryString: 'User Login
In order to use the ToDo application
As a user
I want to login with my personal account'. ! !

!UserLogin class methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:02:45.053'!
libraries

	^ {StWebAppLibrary. StSeleniumLibrary}! !

!UserLogin methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:02:16.729'!
login with test account

	Given the ToDo Application is started
	When I insert tester@example.org as email
	And I insert test as password
	And I push the Login button
	Then I am logged in! !

!UserLogin methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:04:30.073'!
try to login with empty credentials

	Given the ToDo Application is started
	When I push the Login button
	Then I notice the error message Login failed.! !

!UserLogin methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:06:38.451'!
try to login with wrong e-mail

	Given the ToDo Application is started
	When I insert michael.perscheid@hpi.uni-potsdam.de as email
	And I insert test as password
	And I push the Login button
	Then I notice the error message Login failed.! !

!UserLogin methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:07:24.353'!
try to login with wrong password

	Given the ToDo Application is started
	When I insert tester@example.org as email
	And I insert wrong as password
	And I push the Login button
	Then I notice the error message Login failed.! !

ACUserStory subclass: #UserLogout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!UserLogout class methodsFor: 'initialize-release' stamp: 'mp 3/31/2011 10:11:49.713'!
initialize
	
	super initialize.
	self userStoryString: 'User Logout
In order to leave the ToDo application
As a user
I want to logout'. ! !

!UserLogout class methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:18:02.239'!
libraries

	^ {StWebAppLibrary. StSeleniumLibrary}! !

!UserLogout methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 12:19:55.935'!
logout

	Given I am logged in
	When I click Logout
	Then I am on the start page! !

WAComponent subclass: #StListComponent
	instanceVariableNames: 'items filterBlock sortBlock renderItemBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:31'!
filterBlock

	^ filterBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
filterBlock: anObject

	filterBlock := anObject.! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
items

	^ items! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
items: anObject

	items := anObject.! !

!StListComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:28'!
renderContentOn: html

	html table: [(self sortBlock
		value: (self filterBlock value: self items))
		do: [:item | html tableRow: [self renderItemBlock
							value: item
							value: html]]].! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
renderItemBlock

	^ renderItemBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
renderItemBlock: anObject

	renderItemBlock := anObject.! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
sortBlock

	^ sortBlock! !

!StListComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:32'!
sortBlock: anObject

	sortBlock := anObject.! !

WAComponent subclass: #StLoggedInComponent
	instanceVariableNames: 'menuComponent listComponent taskEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:19'!
children

	^ Array with: self menuComponent with: self listComponent! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 14:56'!
createNewTask

	(self lightbox: self taskEditor newTask) ifFalse: [^ self].
	self session database
		addTask: self taskEditor task
		toUser: self session user.! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 14:57'!
editTask: aTask
	
	self taskEditor task: aTask copy.
	(self lightbox: self taskEditor) ifFalse: [^ self].
	aTask copyFrom: self taskEditor task.
	self session database save: aTask.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:30'!
initialize

	super initialize.
	self
		initializeMenuComponent;
		initializeListComponent.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 14:22'!
initializeListComponent

	self listComponent: StListComponent new.
	self listComponent
		sortBlock: [:items |
			items sortBy: [:a :b | a deadline < b deadline]];
		renderItemBlock: [:task :html |
			self renderTask: task asRowOn: html];
		items: self session user tasks.
	self showPendingTasks.! !

!StLoggedInComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 12:32'!
initializeMenuComponent

	self menuComponent:(StMenuComponent new
		addEntry: 'All' withAction: [self showAllTasks];
		addEntry: 'Completed' withAction: [self showCompletedTasks];
		addEntry: 'Pending' withAction: [self showPendingTasks];
		addEntry: 'Missed' withAction: [self showMissedTasks];
		addEntry: 'New Task' withAction: [self createNewTask];
		addEntry: 'Logout' withAction: [self session logout. self answer: true];
		yourself).! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
listComponent

	^ listComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
listComponent: anObject

	listComponent := anObject.! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
menuComponent

	^ menuComponent! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
menuComponent: anObject

	menuComponent := anObject.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'mp 3/31/2011 17:43:06.709'!
renderCheckboxWith: aTask on: html

	| updater |
	updater := html updater
		id: 'list';
		callback: [:renderer |
			aTask completed: aTask completed not.
			renderer render: self listComponent];
		yourself.
	html checkbox
		id: 'completedCheckbox';
		onClick: updater;
		value: aTask completed.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 11:26'!
renderContentOn: html

	html div
		class: 'generic';
		with:[
			html heading: 'ToDo-List of ', self session user userName.
			html div
			class: 'menu';
			with: self menuComponent.
			html div
			class: 'list';
			id: 'list';
			with: self listComponent].! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 14:44'!
renderInPlaceEditorWith: aTask on: html

	| editor |
	editor := html inPlaceEditor
		cancelControl: false;
		triggerInPlaceEditor: [:value | aTask taskName: value];
		callback: [:renderer | renderer render: aTask taskName];
		yourself.
	html div
		script: editor;
		with: aTask taskName.! !

!StLoggedInComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 14:45'!
renderTask: aTask asRowOn: html

	html tableData: [html
		tableData: [self renderCheckboxWith: aTask on: html];
		tableData: aTask deadline asString;
		tableData: [self renderInPlaceEditorWith: aTask on: html];
		tableData: aTask taskDescription;
		tableData: [html anchor
					callback: [self editTask: aTask];
					with: 'edit']].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showAllTasks

	self listComponent
		filterBlock: [:items | items].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showCompletedTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item completed]].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:32'!
showMissedTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item isMissed]].! !

!StLoggedInComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 10:31'!
showPendingTasks

	self listComponent
		filterBlock: [:items | items select: [:item | item isPending]].! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:06'!
taskEditor
    
	^ taskEditor ifNil: [taskEditor := StTaskEditor new]! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
taskEditor: anObject

	taskEditor := anObject.! !

!StLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
testTasks

	^ OrderedCollection
		with: (StTask new
			deadline: Date yesterday;
			completed: false;
			taskName: 'Missed task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: false;
			taskName: 'Pending task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: true;
			taskName: 'Already completed task')! !

WAComponent subclass: #StLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:51'!
applicationName

	^ StToDoLibrary applicationName ! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:34'!
email

	^ email! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
email: anObject

	email := anObject.! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/10/2008 10:37'!
hashPassword: aString

	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].
	! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:31'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!StLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent

	^ messageComponent ifNil: [messageComponent := StMessageComponent new]! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
messageComponent: anObject

	messageComponent := anObject.! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
password

	^ password! !

!StLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
password: anObject

	password := anObject.! !

!StLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:32'!
registerUser
	
	self answer: #registerUser.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'dt 4/11/2008 19:57'!
renderContentOn: html

	html div
	class: 'generic';
	with: [
		html
			heading: self applicationName;
			render: self messageComponent;
			text: 'Please login with e-mail and password:';
			form: [
				self
					renderTextInputOn: html;
					renderPasswordInputOn: html;
					renderLoginButtonOn: html;
					renderSignUpAnchorOn: html]].! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderLoginButtonOn: html

	html submitButton
		callback: [self validateLogin];
		text: 'Login'.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'mp 3/30/2011 16:11:55.002'!
renderPasswordInputOn: html

	html passwordInput
		id: 'password';
		callback: [:value | self password: (self hashPassword: value)];
		value: ''.! !

!StLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:16'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
		callback: [self registerUser];
		with: [html text: 'Sign up for the ', self applicationName]].! !

!StLoginComponent methodsFor: 'rendering' stamp: 'mp 3/30/2011 16:10:46.598'!
renderTextInputOn: html

	html textInput
		id: 'email';
		on: #email of: self;
		value: ''.
	html space.! !

!StLoginComponent methodsFor: 'actions' stamp: 'dt 4/11/2008 19:40'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user password = self password])
		ifTrue: [self answer: user]
		ifFalse: [self loginFailed].! !

WAComponent subclass: #StMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMenuComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:21'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!StMenuComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:36'!
entries

	^ entries! !

!StMenuComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
entries: anObject

	entries := anObject.! !

!StMenuComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:23'!
initialize

	super initialize.
	self entries: OrderedCollection new.! !

!StMenuComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:22'!
renderContentOn: html

	self entries
		do: [:entry |
			html anchor
				callback: entry value;
				with: entry key]
		separatedBy: [html space].! !

WAComponent subclass: #StMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StMessageComponent commentStamp: 'ab 7/17/2007 14:36' prior: 0!
I can display information messages like errors or confirmations!

!StMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:17'!
errorMessage: aString

	self
		messageString: aString;
		messageType: 'error';
		wasShown: false.! !

!StMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:18'!
infoMessage: aString

	self
		messageString: aString;
		messageType: 'info';
		wasShown: false.! !

!StMessageComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 13:15'!
initialize

	super initialize.
	self wasShown: true.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageString

	^ messageString! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageString: anObject

	messageString := anObject.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageType

	^ messageType! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageType: anObject

	messageType := anObject.! !

!StMessageComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 13:18'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
	html div
		class: self messageType, 'Message';
		with: self messageString.! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
wasShown

	^ wasShown! !

!StMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
wasShown: anObject

	wasShown := anObject.! !

WAComponent subclass: #StRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRegisterComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:01'!
hashPassword: aString
	
	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].! !

!StRegisterComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 12:52'!
initialize

	super initialize.
	self user: StUser new.
	! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 12:56'!
messageComponent

	^ messageComponent ifNil: [messageComponent := StMessageComponent new]! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:38'!
messageComponent: anObject

	messageComponent := anObject.! !

!StRegisterComponent methodsFor: 'actions' stamp: 'dt 4/13/2008 12:44'!
registerUser
    
	self user userName isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a username!!'].
	self user email isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please enter your e-mail address!!'].
	(self session findUserByEmail: self user email)
		ifNotNil: [^ self messageComponent errorMessage: 'The e-mail address is already registered!!'].
	self user password = 0
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a password!!'].
	self user password = self repeatedPassword
		ifFalse: [^ self messageComponent infoMessage: 'Your repeated password does not match!!'].
	self session database addUser: self user.
	self answer: self user.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:58'!
renderCancelButtonOn: html
	
	html submitButton
		callback: [self answer: nil];
		text: 'Cancel'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:54'!
renderContentOn: html

	html div
		class: 'generic';
		with: [
			html
				heading: 'Register';
				render: self messageComponent;
				form: [
					html table: [
						self
							renderUsernameTextInputOn: html;
							renderEmailTextInputOn: html;
							renderPasswordTextInputOn: html;
							renderRepeatedPasswordTextInputOn: html.
						html tableRow: [
							html
								tableData;
								tableData: [
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html]]]]].
	! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'mp 3/31/2011 11:36:35.019'!
renderEmailTextInputOn: html

	html tableRow: [
		html
			tableData: 'E-mail';
			tableData: [
				html textInput
					id: 'email';
					callback: [:value | self user email: value];
					value: self user email]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'mp 3/31/2011 11:36:46.108'!
renderPasswordTextInputOn: html
    
	html tableRow: [
		html
			tableData: 'Password';
			tableData: [
				html passwordInput
					id: 'password';
					callback: [:value | self user password: (self hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'mp 3/31/2011 11:36:58.701'!
renderRepeatedPasswordTextInputOn: html
  
	html tableRow: [
		html
			tableData: 'Repeat password';
			tableData: [
				html passwordInput
					id: 'repeated password';
					callback: [:value | self repeatedPassword: (self hashPassword: value)]]].! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:57'!
renderSubmitButtonOn: html

	html submitButton
		callback: [self registerUser];
		text: 'Register'.! !

!StRegisterComponent methodsFor: 'rendering' stamp: 'mp 3/31/2011 11:36:20.147'!
renderUsernameTextInputOn: html

	html tableRow: [
		html
		tableData: 'Username';
		tableData: [
			html textInput
				id: 'username';
				callback: [:value | self user userName: value];
				value: self user userName]].! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:38'!
repeatedPassword

	^ repeatedPassword! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
repeatedPassword: anObject

	repeatedPassword := anObject.! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user

	^ user! !

!StRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user: anObject

	user := anObject.! !

WAComponent subclass: #StTaskEditor
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTaskEditor methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:53'!
initialize

	super initialize.
	self task: StTask new.! !

!StTaskEditor methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:14'!
newTask

	self task: StTask new.! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:58'!
renderButtonsOn: html

	html
		tableData;
		tableData: [
			html submitButton
				callback: [self answer: true];
				value: 'Save'.
			html submitButton
				callback: [self answer: false];
				value: 'Cancel'].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'mp 3/31/2011 14:19:56.443'!
renderCompletedSelectionOn: html

	html
		tableData: [html text: 'Completed: '];
		tableData: [
			html select
				id: 'completed';
				add: true;
				add: false;
				on: #completed of: self task;
				labels: [:value |
					value
						ifTrue: ['yes']
						ifFalse: ['no']]].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:55'!
renderContentOn: html

	html div
		class: 'generic lightbox';
		with: [
			html heading: 'Editing task'.
			html form: [
				html table: [
					html
						tableRow: [self renderNameInputOn: html];
						tableRow: [self renderDescriptionInputOn: html];
						tableRow: [self renderDateInputOn: html];
						tableRow: [self renderCompletedSelectionOn: html];
						tableRow: [self renderButtonsOn: html]]]].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'mp 3/31/2011 14:19:37.036'!
renderDateInputOn: html

	html
		tableData: [html text: 'Deadline: '];
		tableData: [html dateInput 
					id: 'deadline';
					on: #deadline of: self task].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'mp 3/31/2011 14:19:19.692'!
renderDescriptionInputOn: html

	html
		tableData: [html text: 'Description: '];
		tableData: [html textArea 
					id: 'description';
					on: #taskDescription of: self task].! !

!StTaskEditor methodsFor: 'rendering' stamp: 'mp 3/31/2011 14:18:38.137'!
renderNameInputOn: html

	html
		tableData: [html text: 'Name: '];
		tableData: [html textInput 
			id: 'name';
			on: #taskName of: self task].! !

!StTaskEditor methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
task

	^ task! !

!StTaskEditor methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
task: anObject

	task := anObject.! !

WATask subclass: #StRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StRootTask class methodsFor: 'testing' stamp: 'micper 4/9/2008 11:39'!
canBeRoot

	^ true! !

!StRootTask class methodsFor: 'testing' stamp: 'micper 4/9/2008 16:59'!
initialize

	(self registerAsApplication: 'todo')
		addLibrary: SULibrary;
		addLibrary: StToDoLibrary;
		preferenceAt: #sessionClass put: StSession.! !

!StRootTask methodsFor: 'processing' stamp: 'dt 4/11/2008 19:57'!
go

	| loginAnswer user |
	loginAnswer := self call: StLoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: StRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user ifNotNil: [
		self session login: user.
		self call: StLoggedInComponent new].! !

ACLibrary subclass: #StSeleniumLibrary
	instanceVariableNames: 'webTester'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!StSeleniumLibrary methodsFor: 'accessing' stamp: 'mp 3/31/2011 10:01:19.984'!
defaultAppRoot
	^ 'http://localhost:8080/todo/'! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 3/31/2011 17:47:59.037'!
(given) click :aString

	(self webTester link: aString) click waitForPageToLoad.! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 4/1/2011 11:01:47.755'!
(given) has a not completed task with :title and :description for :dateString

	StImageDatabase users first addTask: (StTask new
										taskName: title;
										taskDescription: description;
										deadline: (Date perform: dateString asSymbol)).	! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 3/31/2011 16:02:35.687'!
(given) has three different kinds of tasks

	StImageDatabase users first addTask: (StTask new
												taskName: 'task1';
												taskDescription: 'completed task';
												completed: true;
												deadline: Date yesterday).
												
	StImageDatabase users first addTask: (StTask new
												taskName: 'task2';
												taskDescription: 'missed task';
												completed: false;
												deadline: Date yesterday).

	StImageDatabase users first addTask: (StTask new
												taskName: 'task3';
												taskDescription: 'still pending task';
												completed: false;
												deadline: Date tomorrow).																							! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 3/31/2011 12:17:52.518'!
(given) is logged in

	self scenario given: 'the ToDo Application is started'.
	(self webTester textFieldById: 'email') text: 'tester@example.org'.
	(self webTester textFieldById: 'password') text: 'test'.
	(self webTester buttonByValue: 'Login') click waitForPageToLoad.! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 3/31/2011 11:40:51.206'!
(given) is on the registration form

	self scenario givenScenario: #'start registration form'! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 3/31/2011 11:23:43.286'!
(given) the ToDo Application is started

	self webTester openUrl: self defaultAppRoot.! !

!StSeleniumLibrary methodsFor: 'given' stamp: 'mp 3/30/2011 16:40:45.015'!
(given) the web server is up

! !

!StSeleniumLibrary methodsFor: 'initialize-release' stamp: 'mp 3/30/2011 16:51:23.21'!
setUp

	self webTester: (WtSeleniumWebTester new
						appRoot: self defaultAppRoot;
						browserType: '*chrome').
	self webTester start.! !

!StSeleniumLibrary methodsFor: 'initialize-release' stamp: 'mp 3/30/2011 16:50:34.525'!
tearDown

	self webTester stop.! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/31/2011 15:08:00.29'!
(then) dont find a todo entry with :title and :description
	
	(self webTester link: 'All') click waitForPageToLoad.
	self deny: (self webTester isTextPresent: title).
	self deny: (self webTester isTextPresent: description).! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/31/2011 16:05:06.561'!
(then) dont see a todo entry with :title and :description
	
	self deny: (self webTester isTextPresent: title).
	self deny: (self webTester isTextPresent: description).! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/31/2011 14:27:36.89'!
(then) find a :completed todo entry for :date with :title and :description
	| complete deadline anchor todoTitle todoDescription |
	complete := (completed beginsWith: 'not') not.
	deadline := Date perform: date asSymbol.
	todoTitle := (title = 'no title')
					ifTrue: ['']
					ifFalse: [title].
	todoDescription := (description= 'no description')
					ifTrue: ['']
					ifFalse: [description].
	
	complete
		ifTrue: [anchor := 'Completed']
		ifFalse: [
			Date today <= deadline
				ifTrue: [anchor := 'Pending']
				ifFalse: [anchor := 'Missed']].
	(self webTester link: anchor) click waitForPageToLoad.
	
	self assert: (self webTester isTextPresent: deadline asString).
	self assert: (self webTester isTextPresent: todoTitle).
	self assert: (self webTester isTextPresent: todoDescription).! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/31/2011 11:40:40.173'!
(then) is logged in

	self assert: (self webTester isTextPresent: 'ToDo-List of').! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/31/2011 12:20:23.95'!
(then) is on the start page

	self assert: (self webTester isTextPresent: 'ToDo Application').! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/31/2011 11:50:39.47'!
(then) notice the error message :aString

	self assert: (self webTester isTextPresent: aString).! !

!StSeleniumLibrary methodsFor: 'then' stamp: 'mp 3/30/2011 16:53:11.771'!
(then) see :aString

	self assert: (self webTester isTextPresent: aString).! !

!StSeleniumLibrary methodsFor: 'accessing' stamp: 'mp 3/30/2011 16:45:04.772'!
webTester
	"Answer the value of webTester"

	^ webTester! !

!StSeleniumLibrary methodsFor: 'accessing' stamp: 'mp 3/30/2011 16:45:04.784'!
webTester: anObject
	"Set the value of webTester"

	webTester := anObject! !

!StSeleniumLibrary methodsFor: 'when' stamp: 'mp 3/31/2011 14:52:14.27'!
(when) change the deadline to :aString
	| deadline |
	deadline := Date perform: aString asSymbol.
	(self webTester comboBox: 'deadline') select: deadline month name asString.
	(self webTester textFieldById: 'deadline-day') text: deadline dayOfMonth asString.
	(self webTester textFieldById: 'deadline-year') text: deadline year asString.! !

!StSeleniumLibrary methodsFor: 'when' stamp: 'mp 3/31/2011 14:54:48.108'!
(when) change the task to complete
	
	(self webTester comboBox: 'completed') select: 'yes'.! !

!StSeleniumLibrary methodsFor: 'when' stamp: 'mp 3/31/2011 11:24:47.187'!
(when) click :aString

	(self webTester link: aString) click waitForPageToLoad.! !

!StSeleniumLibrary methodsFor: 'when' stamp: 'mp 3/31/2011 11:35:37.035'!
(when) insert :aString as :id
	
	(self webTester textFieldById: id) text: aString.! !

!StSeleniumLibrary methodsFor: 'when' stamp: 'mp 3/31/2011 11:46:25.256'!
(when) push the :aString button

	(self webTester buttonByValue: aString) click waitForPageToLoad.! !

!StSeleniumLibrary methodsFor: 'when' stamp: 'mp 3/30/2011 16:52:25.133'!
(when) request the url :aString

	self webTester openUrl: aString.! !

ACLibrary subclass: #StWebAppLibrary
	instanceVariableNames: 'oldUsers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-UserStories'!

!StWebAppLibrary methodsFor: 'accessing' stamp: 'mp 3/31/2011 11:10:27.601'!
oldUsers
	"Answer the value of oldUsers"

	^ oldUsers! !

!StWebAppLibrary methodsFor: 'accessing' stamp: 'mp 3/31/2011 11:10:27.612'!
oldUsers: anObject
	"Set the value of oldUsers"

	oldUsers := anObject! !

!StWebAppLibrary methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:18:38.392'!
setUp
	self oldUsers: StImageDatabase users.
	StImageDatabase users: OrderedCollection new.
	StImageDatabase users add: (StUser new
									userName: 'Tester';
									email: 'tester@example.org';
									password: (SecureHashAlgorithm new 
													hashMessage: 'test')).! !

!StWebAppLibrary methodsFor: 'as yet unclassified' stamp: 'mp 3/31/2011 11:18:33.341'!
tearDown
	StImageDatabase users: self oldUsers.! !

Object subclass: #StImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex'
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:10'!
users
	
	^ Users ifNil: [Users := OrderedCollection new]! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:31'!
users: anObject

	Users := anObject.! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:12'!
writeMutex
	
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!StImageDatabase class methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:31'!
writeMutex: anObject

	WriteMutex := anObject.! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:17'!
addTask: aTask toUser: aUser

	aUser addTask: aTask.
	self saveImage.
	^ aTask! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:16'!
addUser: aUser

	self class users add: aUser.
	self saveImage.
	^ aUser! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:18'!
connectionFailed

	^ false! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:18'!
disconnect! !

!StImageDatabase methodsFor: 'accessing' stamp: 'micper 4/9/2008 14:17'!
findUserByEmail: anEmail

	^ self class users
		detect: [:each | each email = anEmail]
		ifNone: [nil]! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:18'!
save: anObject! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:14'!
saveImage

	self class writeMutex critical: [self saveImageWithoutMonitor].! !

!StImageDatabase methodsFor: 'actions' stamp: 'micper 4/9/2008 14:11'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession.! !

Object subclass: #StTask
	instanceVariableNames: 'completed deadline taskDescription id taskName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
completed

	^ completed! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
completed: anObject

	completed := anObject.! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
deadline

	^ deadline! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
deadline: anObject

	deadline := anObject.! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
id

	^ id! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:40'!
id: anObject

	id := anObject.! !

!StTask methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:13'!
initialize

	self
		deadline: Date tomorrow;
		completed: false.! !

!StTask methodsFor: 'comparing' stamp: 'micper 4/9/2008 10:12'!
isMissed

	^ self completed not and: [self deadline < Date today]! !

!StTask methodsFor: 'comparing' stamp: 'micper 4/9/2008 10:11'!
isPending

	^ self completed not and: [self deadline >= Date today]! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskDescription

	^ taskDescription! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskDescription: anObject

	taskDescription := anObject.! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskName

	^ taskName! !

!StTask methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
taskName: anObject

	taskName := anObject.! !

Object subclass: #StUser
	instanceVariableNames: 'id userName email tasks password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StUser commentStamp: 'PO 9/6/2007 16:30' prior: 0!
I am the User of the Tutorial ToDo-Application

I own my categories in a SortedList
And my tasks in a Set!

!StUser methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:09'!
addTask: aTask
	
	^ self tasks add: aTask! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
email

	^ email! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
email: anObject

	email := anObject.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
id

	^ id! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
id: anObject

	id := anObject.! !

!StUser methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:08'!
initialize
	
	self tasks: OrderedCollection new.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
password

	^ password! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
password: anObject

	password := anObject.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
tasks

	^ tasks! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
tasks: anObject

	tasks := anObject.! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:42'!
userName

	^ userName! !

!StUser methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:43'!
userName: anObject

	userName := anObject.! !

WAFileLibrary subclass: #StToDoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp'!

!StToDoLibrary class methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:50'!
applicationName

	^ 'ToDo Application'! !

!StToDoLibrary methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:53'!
selectorsToInclude

	^ #( todoCss )! !

!StToDoLibrary methodsFor: 'uploaded' stamp: 'dt 4/13/2008 13:07'!
todoCss

	^ '
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
	
.generic {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-style: normal;
	font-weight: normal;
	font-size: 14px;
	color : #663300;
	padding: 20px;
	margin-top: 20px;
	margin-left: 20px;
	border: 1px solid #663300;
	width: 500px;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
	border: 1px solid #ee0000;
	padding: 5px;
	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
	border: 1px solid #eda33a;
	padding: 5px;
	margin-bottom: 10px;
}

a {
	color : #663300;
	text-decoration: underline;
}'! !

WtSeleniumCase subclass: #StSeleniumTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STTutTodoApp-Tests'!

!StSeleniumTest class methodsFor: 'as yet unclassified' stamp: 'mp 3/30/2011 15:45:03.611'!
defaultAppRoot
	^'http://localhost:8080/todo'! !

!StSeleniumTest methodsFor: 'running' stamp: 'mp 3/30/2011 15:47:30.478'!
setUp
	self openAtDefault! !

!StSeleniumTest methodsFor: 'running' stamp: 'mp 3/30/2011 16:15:01.87'!
testEmptyLogin
	self assert: (self textFieldById: 'email') isEmpty.
	self assert: (self textFieldById: 'password') isEmpty.
	(self buttonByValue: 'Login') click waitForPageToLoad.
	self assert: (self isTextPresent: 'Login failed.').! !

!StSeleniumTest methodsFor: 'running' stamp: 'mp 3/30/2011 15:59:41.817'!
testLinkToRegistration
	((self link: 'Sign up for the ToDo Application') click) waitForPageToLoad.
	self assert: (self isTextPresent: 'Register').	
	self assert: (self isTextPresent: 'Username').	
	self assert: (self isTextPresent: 'E-mail').	
	self assert: (self isTextPresent: 'Password').						! !

!StSeleniumTest methodsFor: 'running' stamp: 'mp 3/30/2011 16:16:33.494'!
testLogin
	self assert: ((self textFieldById: 'email') text: 'a').
	self assert: ((self textFieldById: 'password') text: 'a').
	(self buttonByValue: 'Login') click waitForPageToLoad.
	self assert: (self isTextPresent: 'ToDo-List of a').	! !

!StSeleniumTest methodsFor: 'running' stamp: 'mp 3/30/2011 15:50:21.941'!
testText
	self assert: (self isTextPresent: 'ToDo Application').
	self assert: (self isTextPresent: 'Please login with e-mail and password:').! !

!StSeleniumTest methodsFor: 'running' stamp: 'mp 3/30/2011 15:48:05.594'!
testTitle
	self assert: self title = 'ToDo Application'! !
CreateNewTask initialize!
EditTask initialize!
RegisteraNewUser initialize!
ShowTasks initialize!
StartToDoApplication initialize!
UserLogin initialize!
UserLogout initialize!
StRootTask initialize!
